/******************************************************************************/
/* Sistemas Integrados TECNISA                                                */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/* Nome: CARG_DESCSOL_COT                                                     */
/*                                                                            */
/* Descrio:                                                                 */
/* Joga para a descrio do Item de Coleta a(s) descrio(es) do(s) item(s)  */
/* de solicitao(es) de compras.                                            */
/*                                                                            */
/* Criao:                                                                   */
/* 10/02/2001 - Adriano de Arajo                                             */
/*                                                                            */
/******************************************************************************/

/******************************************************************************/
/* @C:\SISTEMAS\DBA\SQL\ORACLE\8610_SUPSTP_CARG_DESCSOL_COT.SQL               */
/* @H:\SISTEMAS\DBA\SQL\ORACLE\8610_SUPSTP_CARG_DESCSOL_COT.SQL               */
/******************************************************************************/

CREATE OR REPLACE PROCEDURE CARG_DESCSOL_COT
         (P_CDFILIAL    IN COLETAPR.CDFILIAL%TYPE,
          P_NRCOLEPRECO IN COLETAPR.NRCOLEPRECO%TYPE,
          P_DTINI       IN ITEMCOLE.DTINIVALITM%TYPE,
          P_DTFIN       IN ITEMCOLE.DTFINVALITM%TYPE)
IS
  V_DSOBSITMCOL ITEMCOLE.DSOBSITMCOL%TYPE;
BEGIN
  FOR C_COTA IN
   (SELECT
      DISTINCT
       CDREGIAO,
       CDPRODUTO
    FROM
      ITEMCOLE
    WHERE
       CDFILIAL    = P_CDFILIAL    AND
       NRCOLEPRECO = P_NRCOLEPRECO AND
       QTACMPITMCOL > 0)
  LOOP
     V_DSOBSITMCOL := NULL;
     FOR C_SOL IN
      (SELECT
         ITEMSOLI.TXOBSITMSOL
       FROM
         ITEMSOLI,
         FILIAL
       WHERE
         ITEMSOLI.IDITMCONS = 'N'              AND
         ITEMSOLI.TXOBSITMSOL IS NOT NULL      AND
         FILIAL.CDREGIAO    = C_COTA.CDREGIAO  AND
         ITEMSOLI.CDFILSOLI = FILIAL.CDFILIAL  AND
         ITEMSOLI.CDPRODUTO = C_COTA.CDPRODUTO AND
         ITEMSOLI.DTPROGENTR BETWEEN P_DTINI AND P_DTFIN AND
     		NVL(ITEMSOLI.IDSOLIAPROV,'S') = 'S')
     LOOP
       IF V_DSOBSITMCOL IS NULL THEN
         V_DSOBSITMCOL := SUBSTR(C_SOL.TXOBSITMSOL, 1, 1000);
       ELSE
         V_DSOBSITMCOL := SUBSTR(V_DSOBSITMCOL || CHR(13) || C_SOL.TXOBSITMSOL, 1, 1000);
       END IF;
     END LOOP;

     UPDATE ITEMCOLE
     SET DSOBSITMCOL = SUBSTR(V_DSOBSITMCOL, 1, 1000)
     WHERE
       CDFILIAL    = P_CDFILIAL       AND
       NRCOLEPRECO = P_NRCOLEPRECO    AND
       CDREGIAO    = C_COTA.CDREGIAO  AND
       CDPRODUTO   = C_COTA.CDPRODUTO AND
       QTACMPITMCOL > 0;
  END LOOP;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('CARG_DESCSOL_COT','5.40.000'); END;
/
